VSTGUI 4.5 Graphical User Interface Framework not only for VST plugins

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Groups Pages
Classes | Public Types | Public Member Functions | Protected Types | Protected Member Functions | List of all members
CView Class Reference
Views

Base Class of all view objects. More...

Inheritance diagram for CView:

## Classes
struct | Impl

## Public Types
enum | MouseListenerCall { MouseDown, MouseMoved, MouseUp, MouseCancel }

## Public Member Functions
| CView (const CRect &size)
| CView (const CView &view)
void | setSubviewState (bool state)
bool | isSubview () const
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes More...
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes More...
void | setTooltipText (UTF8StringPtr text)
virtual CViewContainer * | asViewContainer ()
virtual const CViewContainer * | asViewContainer () const
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
void | beforeDelete () override
CBaseObject * | newCopy () const override
Mouse Methods
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| called when a mouse down event occurs More...
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| called when a mouse up event occurs More...
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| called when a mouse move event occurs More...
virtual CMouseEventResult | onMouseCancel ()
| called when mouse tracking should be canceled More...
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| called when the mouse enters this view More...
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| called when the mouse leaves this view More...
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const CButtonState &buttons=-1)
| check if where hits this view More...
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons)
| called if a mouse wheel event is happening over this view More...
virtual bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons)
| called if a mouse wheel event is happening over this view More...
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view More...
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not More...
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse More...
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse More...
const CRect & | getMouseableArea () const
| read only access to the mouseable area More...
Drag & Drop Methods
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| start a drag operation More...
virtual SharedPointer < IDropTarget > | getDropTarget ()
| get the drag target for drag and drop handling More...
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target More...
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown More...
Keyboard Methods
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus More...
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus More...
View Size Methods
CCoord | getHeight () const
| get the height of the view More...
CCoord | getWidth () const
| get the width of the view More...
virtual void | setViewSize (const CRect &rect, bool invalid=true)
| set views size More...
const CRect & | getViewSize () const
| read only access to view size More...
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view More...
virtual void | parentSizeChanged ()
| notification that one of the views parent has changed its size More...
virtual CPoint & | frameToLocal (CPoint &point) const
| conversion from frame coordinates to local view coordinates More...
virtual CPoint & | localToFrame (CPoint &point) const
| conversion from local view coordinates to frame coordinates More...
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags More...
int32_t | getAutosizeFlags () const
| get autosize flags More...
virtual bool | sizeToFit ()
| resize view to optimal size More...
Focus Methods
virtual void | looseFocus ()
| called if view should loose focus More...
virtual void | takeFocus ()
| called if view should take focus More...
virtual bool | wantsFocus () const
| check if view supports focus More...
virtual void | setWantsFocus (bool state)
| set focus support on/off More...
Attribute Methods
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute More...
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute More...
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute More...
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute More...
template<typename T >
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute More...
template<typename T >
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute More...
Background Methods
virtual void | setBackground (CBitmap *background)
| set the background image of this view More...
CBitmap * | getBackground () const
| get the background image of this view More...
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled More...
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled More...
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state. More...
Transparency Methods
virtual void | setTransparency (bool val)
| set views transparent state More...
bool | getTransparency () const
| get views transparent state More...
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view More...
float | getAlphaValue () const
| get alpha value More...
Attaching Methods
virtual bool | removed (CView *parent)
| view is removed from parent view More...
virtual bool | attached (CView *parent)
| view is attached to a parent view More...
bool | isAttached () const
| is view attached to a parentView More...
Parent Methods
CView * | getParentView () const
| get parent view More...
CFrame * | getFrame () const
| get frame More...
virtual VSTGUIEditorInterface * | getEditor () const
| get editor More...
Animation Methods
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject=nullptr)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
View Listener Methods
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
Coordinate translation Methods
CGraphicsTransform | getGlobalTransform () const
| get the active global transform for this view More...
template<typename T >
T & | translateToGlobal (T &t) const
| translates a local coordinate to a global one using parent transforms More...
template<typename T >
T | translateToGlobal (const T &t) const
| translates a local coordinate to a global one using parent transforms More...
template<typename T >
T & | translateToLocal (T &t) const
| translates a global coordinate to a local one using parent transforms More...
template<typename T >
T | translateToLocal (const T &t) const
| translates a local coordinate to a global one using parent transforms More...
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexceptoverride=default
| CBaseObject (const CBaseObject &o)
CBaseObject & | operator= (const CBaseObject &obj)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0 More...
void | remember () override
| increase refcount More...
virtual int32_t | getNbReference () const
| get refcount More...

## Protected Types
enum | { kMouseEnabled = 1 << 0, kTransparencyEnabled = 1 << 1, kWantsFocus = 1 << 2, kIsAttached = 1 << 3, kVisible = 1 << 4, kDirty = 1 << 5, kWantsIdle = 1 << 6, kIsSubview = 1 << 7, kLastCViewFlag = 7 }

## Protected Member Functions
| ~CView () noexceptoverride
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)

## Draw and Update Methods
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle. More...
virtual void | draw (CDrawContext *pContext)
| called if the view should draw itself More...
virtual void | drawRect (CDrawContext *pContext, const CRect &updateRect)
| called if the view should draw itself More...
virtual bool | checkUpdate (const CRect &updateRect) const
virtual bool | isDirty () const
| check if view is dirty More...
virtual void | setDirty (bool val=true)
| set the view to dirty so that it is redrawn in the next idle. More...
virtual void | invalidRect (const CRect &rect)
| mark rect as invalid More...
virtual void | invalid ()
| mark whole view as invalid More...
virtual void | setVisible (bool state)
| set visibility state More...
bool | isVisible () const
| get visibility state More...

## Idle Methods
Should be used when a view needs to do a task periodically. The onIdle() method will be called only if the view is attached.
static uint32_t | idleRate
| global idle rate in Hz, defaults to 30 Hz More...
virtual void | onIdle ()
| called on idle when view wants idle More...
void | setWantsIdle (bool state)
| enable/disable onIdle() callback More...
bool | wantsIdle () const
| returns if the view wants idle callback or not More...

## Detailed Description

Base Class of all view objects.

## Member Enumeration Documentation

anonymous enum
| protected

Enumerator
kMouseEnabled |
kTransparencyEnabled |
kWantsFocus |
kIsAttached |
kVisible |
kDirty |
kWantsIdle |
kIsSubview |
kLastCViewFlag |

enum MouseListenerCall
| strong

Enumerator
MouseDown |
MouseMoved |
MouseUp |
MouseCancel |

## Constructor & Destructor Documentation

CView | ( | const CRect & | size | ) |
| explicit

CView | ( | const CView & | view | ) |

~CView | ( |  | ) |
| override protected default noexcept

## Member Function Documentation

void addAnimation | ( | IdStringPtr | name,
|  | Animation::IAnimationTarget * | target,
|  | Animation::ITimingFunction * | timingFunction,
|  | CBaseObject * | notificationObject = `nullptr`
| ) |  |

void addAnimation | ( | IdStringPtr | name,
|  | Animation::IAnimationTarget * | target,
|  | Animation::ITimingFunction * | timingFunction,
|  | const Animation::DoneFunction & | doneFunc
| ) |  |

virtual CViewContainer* asViewContainer | ( |  | ) |
| inline virtual

Reimplemented in CViewContainer.

virtual const CViewContainer* asViewContainer | ( |  | ) | const
| inline virtual

Reimplemented in CViewContainer.

bool attached | ( | CView * | parent | ) |
| virtual

view is attached to a parent view

Parameters

  parent | parent view

Returns
  true if view successfully attached to parent

Reimplemented in CFrame, CViewContainer, CSegmentButton, CDataBrowser, CSplitView, CFontChooser, UIViewSwitchContainer, COpenGLView, CShadowViewContainer, CLayeredViewContainer, and CAutoLayoutContainerView.

void beforeDelete | ( |  | ) |
| override virtual

Reimplemented from ReferenceCounted< T >.

Reimplemented in CViewContainer.

CMouseEventResult callMouseListener | ( | MouseListenerCall | type,
|  | CPoint | pos,
|  | CButtonState | buttons
| ) |  |

void callMouseListenerEnteredExited | ( | bool | mouseEntered | ) |

virtual bool checkUpdate | ( | const CRect & | updateRect | ) | const
| inline virtual

bool doDrag | ( | const DragDescription & | dragDescription,
|  | const SharedPointer< IDragCallback > & | callback = `{}`
| ) |  |

start a drag operation

A drag can only be started from within onMouseDown or onMouseMove.

This method may return immediately before the drop occurs, if you want to be notified about the result you have to provide a callback object.

Parameters

  dragDescription | drag description
  callback | callback

Returns
  true if the drag was started, otherwise false

DragResult doDrag | ( | IDataPackage * | source,
|  | const CPoint & | offset = `CPoint (0, 0)`,
|  | CBitmap * | dragBitmap = `nullptr`
| ) |  |

a drag can only be started from within onMouseDown

Deprecated:
  start a drag operation. See CDropSource to create the source data package

Parameters

  source | source drop
  offset | bitmap offset
  dragBitmap | bitmap to drag

Returns
  see DragResult

void draw | ( | CDrawContext * | pContext | ) |
| virtual

called if the view should draw itself

Parameters

  pContext | draw context in which to draw

Reimplemented in COptionMenu, CTextButton, CFrame, CAnimKnob, CKickButton, CRockerSwitch, CViewContainer, CSegmentButton, CParamDisplay, CSlider, CCheckBox, CControl, CAnimationSplashScreen, CKnob, CTextEdit, CTextLabel, CGradientView, CVuMeter, CScrollbar, COnOffButton, CSwitchBase, CSplashScreen, CAutoAnimation, CMovieBitmap, CMovieButton, CSearchTextEdit, CSpecialDigit, and CXYPad.

virtual void drawRect | ( | CDrawContext * | pContext,
|  | const CRect & | updateRect
| ) |  |
| inline virtual

called if the view should draw itself

Reimplemented in CFrame, CViewContainer, CSegmentButton, CMultiLineTextLabel, CShadowViewContainer, and CLayeredViewContainer.

CPoint & frameToLocal | ( | CPoint & | point | ) | const
| virtual

conversion from frame coordinates to local view coordinates

Parameters

  point | location

Returns
  converted point

Reimplemented in CViewContainer.

float getAlphaValue | ( |  | ) | const

get alpha value

bool getAttribute | ( | const CViewAttributeID | aId,
|  | const uint32_t | inSize,
|  | void * | outData,
|  | uint32_t & | outSize
| ) |  | const

get an attribute

Parameters

  aId | the ID of the Attribute
  inSize | the size of the outData pointer
  outData | a pointer where to copy the attribute data
  outSize | the size in bytes which was copied into outData

Returns
  true if attribute exists and outData was big enough. outSize and outData is valid then.

bool getAttribute | ( | const CViewAttributeID | id,
|  | T & | data
| ) |  | const
| inline

get an attribute

bool getAttributeSize | ( | const CViewAttributeID | aId,
|  | uint32_t & | outSize
| ) |  | const

get the size of an attribute

Parameters

  aId | the ID of the Attribute
  outSize | on return the size of the attribute

Returns
  true if attribute exists. outSize is valid then.

int32_t getAutosizeFlags | ( |  | ) | const

get autosize flags

CBitmap * getBackground | ( |  | ) | const

get the background image of this view

CBitmap * getDisabledBackground | ( |  | ) | const

get background image used when the mouse is not enabled

CBitmap * getDrawBackground | ( |  | ) | const

get the bitmap which is drawn depending on the enabled state.

SharedPointer< IDropTarget > getDropTarget | ( |  | ) |
| virtual

get the drag target for drag and drop handling

Reimplemented in CViewContainer.

VSTGUIEditorInterface * getEditor | ( |  | ) | const
| virtual

get editor

Reimplemented in CFrame.

CFrame * getFrame | ( |  | ) | const

get frame

CGraphicsTransform getGlobalTransform | ( |  | ) | const

get the active global transform for this view

CCoord getHeight | ( |  | ) | const
| inline

get the height of the view

CGraphicsPath * getHitTestPath | ( |  | ) | const
| protected

CRect & getMouseableArea | ( | CRect & | rect | ) | const

get the area in which the view reacts to the mouse

const CRect & getMouseableArea | ( |  | ) | const

read only access to the mouseable area

bool getMouseEnabled | ( |  | ) | const
| inline

get the state of wheather this view uses the mouse or not

CView * getParentView | ( |  | ) | const

get parent view

bool getTransparency | ( |  | ) | const
| inline

get views transparent state

const CRect & getViewSize | ( |  | ) | const

read only access to view size

CRect getVisibleViewSize | ( |  | ) | const
| virtual

returns the visible size of the view

Returns
  visible size of view

CCoord getWidth | ( |  | ) | const
| inline

get the width of the view

bool hasViewFlag | ( | int32_t | bit | ) | const
| protected

bool hitTest | ( | const CPoint & | where,
|  | const CButtonState & | buttons = `-1`
| ) |  |
| virtual

check if where hits this view

Parameters

  where | location
  buttons | button and modifier state

Returns
  true if point hits this view

Reimplemented in CViewContainer, and CSplashScreen.

virtual void invalid | ( |  | ) |
| inline virtual

mark whole view as invalid

Reimplemented in CFrame, CViewContainer, and CLayeredViewContainer.

void invalidRect | ( | const CRect & | rect | ) |
| virtual

mark rect as invalid

Parameters

  rect | rect to invalidate

Reimplemented in CFrame, CViewContainer, COpenGLView, and CLayeredViewContainer.

bool isAttached | ( |  | ) | const
| inline

is view attached to a parentView

virtual bool isDirty | ( |  | ) | const
| inline virtual

check if view is dirty

Reimplemented in CViewContainer, and CControl.

bool isSubview | ( |  | ) | const
| inline

bool isVisible | ( |  | ) | const
| inline

get visibility state

CPoint & localToFrame | ( | CPoint & | point | ) | const
| virtual

conversion from local view coordinates to frame coordinates

Parameters

  point | location

Returns
  converted point

Reimplemented in CViewContainer.

void looseFocus | ( |  | ) |
| virtual

called if view should loose focus

Reimplemented in COptionMenu, CViewContainer, and CTextEdit.

CBaseObject* newCopy | ( |  | ) | const
| inline override

CMessageResult notify | ( | CBaseObject * | sender,
|  | IdStringPtr | message
| ) |  |
| override virtual

Parameters

  sender | message sender
  message | message text

Returns
  message handled or not. See CMessageResult

Reimplemented from CBaseObject.

Reimplemented in CViewContainer.

virtual void onIdle | ( |  | ) |
| inline virtual

called on idle when view wants idle

Reimplemented in CVuMeter.

int32_t onKeyDown | ( | VstKeyCode & | keyCode | ) |
| virtual

called if a key down event occurs and this view has focus

Parameters

  keyCode | key code of pressed key

Returns
  -1 if not handled and 1 if handled

Reimplemented in COptionMenu, CTextButton, CFrame, CKickButton, CRockerSwitch, CSegmentButton, CSlider, CDataBrowser, CCheckBox, CHorizontalSwitch, CKnob, CVerticalSwitch, CFontChooser, CTextEdit, COnOffButton, and CMovieButton.

int32_t onKeyUp | ( | VstKeyCode & | keyCode | ) |
| virtual

called if a key up event occurs and this view has focus

Parameters

  keyCode | key code of pressed key

Returns
  -1 if not handled and 1 if handled

Reimplemented in CTextButton, CFrame, CKickButton, and CRockerSwitch.

CMouseEventResult onMouseCancel | ( |  | ) |
| virtual

called when mouse tracking should be canceled

Reimplemented in CTextButton, CKickButton, CRockerSwitch, CViewContainer, CSlider, CCheckBox, CKnob, CScrollbar, COnOffButton, CSwitchBase, CMovieButton, and CXYPad.

CMouseEventResult onMouseDown | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| virtual

called when a mouse down event occurs

Parameters

  where | mouse location of mouse down
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented in COptionMenu, CTextButton, CFrame, CKickButton, CRockerSwitch, CViewContainer, CSegmentButton, CSlider, CDataBrowser, CCheckBox, CKnob, CAnimationSplashScreen, CTextEdit, CScrollbar, COnOffButton, CSplashScreen, CSwitchBase, CMovieButton, CAutoAnimation, CSearchTextEdit, and CXYPad.

virtual CMouseEventResult onMouseEntered | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| inline virtual

called when the mouse enters this view

Reimplemented in CScrollbar.

virtual CMouseEventResult onMouseExited | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| inline virtual

called when the mouse leaves this view

Reimplemented in CFrame, and CScrollbar.

CMouseEventResult onMouseMoved | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| virtual

called when a mouse move event occurs

Parameters

  where | mouse location of mouse move
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented in CTextButton, CFrame, CKickButton, CRockerSwitch, CViewContainer, CSlider, CCheckBox, CKnob, CScrollbar, COnOffButton, CSwitchBase, CMovieButton, and CXYPad.

CMouseEventResult onMouseUp | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| virtual

called when a mouse up event occurs

Parameters

  where | mouse location of mouse up
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented in CTextButton, CFrame, CKickButton, CRockerSwitch, CViewContainer, CSlider, CCheckBox, CKnob, CScrollbar, COnOffButton, CSwitchBase, CMovieButton, and CXYPad.

bool onWheel | ( | const CPoint & | where,
|  | const float & | distance,
|  | const CButtonState & | buttons
| ) |  |
| virtual

called if a mouse wheel event is happening over this view

Parameters

  where | location
  distance | wheel distance
  buttons | button and modifier state

Returns
  true if handled

Reimplemented in CFrame, CViewContainer, CRockerSwitch, CSlider, CKnob, and CTextLabel.

bool onWheel | ( | const CPoint & | where,
|  | const CMouseWheelAxis & | axis,
|  | const float & | distance,
|  | const CButtonState & | buttons
| ) |  |
| virtual

called if a mouse wheel event is happening over this view

Parameters

  where | location
  axis | mouse wheel axis
  distance | wheel distance
  buttons | button and modifier state

Returns
  true if handled

Reimplemented in CFrame, CViewContainer, CScrollView, CTextLabel, CScrollbar, and CXYPad.

virtual void onWindowActivate | ( | bool | state | ) |
| inline virtual

called when the active state of the window changes

virtual void parentSizeChanged | ( |  | ) |
| inline virtual

notification that one of the views parent has changed its size

Reimplemented in CViewContainer, CTextEdit, COpenGLView, and CLayeredViewContainer.

void registerViewListener | ( | IViewListener * | listener | ) |

void registerViewMouseListener | ( | IViewMouseListener * | listener | ) |

void removeAllAnimations | ( |  | ) |

void removeAnimation | ( | IdStringPtr | name | ) |

bool removeAttribute | ( | const CViewAttributeID | id | ) |

remove an attribute

bool removed | ( | CView * | parent | ) |
| virtual

view is removed from parent view

Parameters

  parent | parent view

Returns
  true if view successfully removed from parent

Reimplemented in CTextButton, CViewContainer, CParamDisplay, CDataBrowser, CSplitView, UIViewSwitchContainer, COpenGLView, CShadowViewContainer, and CLayeredViewContainer.

void setAlphaValue | ( | float | alpha | ) |
| virtual

set alpha value which will be applied when drawing this view

Reimplemented in CLayeredViewContainer.

void setAlphaValueNoInvalidate | ( | float | value | ) |
| protected

bool setAttribute | ( | const CViewAttributeID | aId,
|  | const uint32_t | inSize,
|  | const void * | inData
| ) |  |

set an attribute

copies data into the attribute.

If it does not exist, creates a new attribute.

Parameters

  aId | the ID of the Attribute
  inSize | the size of the outData pointer
  inData | a pointer to the data

Returns
  true if attribute was set

bool setAttribute | ( | const CViewAttributeID | id,
|  | const T & | data
| ) |  |
| inline

set an attribute

void setAutosizeFlags | ( | int32_t | flags | ) |
| virtual

set autosize flags

Reimplemented in CDataBrowser, CScrollView, and CTabView.

void setBackground | ( | CBitmap * | background | ) |
| virtual

set the background image of this view

Parameters

  background | new background bitmap

Reimplemented in CAnimKnob, and CCheckBox.

void setDirty | ( | bool | val = `true` | ) |
| virtual

set the view to dirty so that it is redrawn in the next idle.

Thread Safe !

Reimplemented in CControl, and CVuMeter.

void setDisabledBackground | ( | CBitmap * | background | ) |
| virtual

set background image used when the mouse is not enabled

Parameters

  background | new disabled background bitmap

void setDropTarget | ( | const SharedPointer< IDropTarget > & | dt | ) |

set a custom drop target

void setHitTestPath | ( | CGraphicsPath * | path | ) |

Parameters

  path | the path to use for hit testing. The path will be translated by this views origin, so that the path must not be set again, if the view is moved. Otherwise when the size of the view changes, the path must also be set again.

void setMouseableArea | ( | const CRect & | rect | ) |
| virtual

set the area in which the view reacts to the mouse

void setMouseEnabled | ( | bool | bEnable = `true` | ) |
| virtual

turn on/off mouse usage for this view

void setParentFrame | ( | CFrame * | frame | ) |
| protected

void setParentView | ( | CView * | parent | ) |
| protected

void setSubviewState | ( | bool | state | ) |

void setTooltipText | ( | UTF8StringPtr | text | ) |

void setTransparency | ( | bool | val | ) |
| virtual

set views transparent state

Reimplemented in CScrollView.

void setViewFlag | ( | int32_t | bit,
|  | bool | state
| ) |  |
| protected

void setViewSize | ( | const CRect & | newSize,
|  | bool | doInvalid = `true`
| ) |  |
| virtual

set views size

Parameters

  newSize | rect of new size of view
  doInvalid | if true set view dirty

Reimplemented in CTextButton, CFrame, CViewContainer, CSlider, CSegmentButton, CMultiLineTextLabel, CDataBrowser, CScrollView, CKnob, CTextEdit, CSplitView, CTabView, CTextLabel, CScrollbar, CVuMeter, CGradientView, CShadowViewContainer, COpenGLView, CLayeredViewContainer, and CAutoLayoutContainerView.

void setVisible | ( | bool | state | ) |
| virtual

set visibility state

Reimplemented in COpenGLView.

void setWantsFocus | ( | bool | state | ) |
| virtual

set focus support on/off

Reimplemented in CDataBrowser.

void setWantsIdle | ( | bool | state | ) |

enable/disable onIdle() callback

virtual bool sizeToFit | ( |  | ) |
| inline virtual

resize view to optimal size

Reimplemented in CTextButton, CViewContainer, CKickButton, CAnimKnob, CRockerSwitch, CSlider, CMultiLineTextLabel, CCheckBox, CAnimationSplashScreen, CKnob, CRowColumnView, CSplitView, CTextLabel, CVuMeter, COnOffButton, CSwitchBase, CMovieButton, and CMovieBitmap.

void takeFocus | ( |  | ) |
| virtual

called if view should take focus

Reimplemented in COptionMenu, CViewContainer, and CTextEdit.

T& translateToGlobal | ( | T & | t | ) | const
| inline

translates a local coordinate to a global one using parent transforms

T translateToGlobal | ( | const T & | t | ) | const
| inline

translates a local coordinate to a global one using parent transforms

T& translateToLocal | ( | T & | t | ) | const
| inline

translates a global coordinate to a local one using parent transforms

T translateToLocal | ( | const T & | t | ) | const
| inline

translates a local coordinate to a global one using parent transforms

void unregisterViewListener | ( | IViewListener * | listener | ) |

void unregisterViewMouseListener | ( | IViewMouseListener * | listener | ) |

virtual bool wantsFocus | ( |  | ) | const
| inline virtual

check if view supports focus

Reimplemented in CDataBrowser, and CTextEdit.

bool wantsIdle | ( |  | ) | const
| inline

returns if the view wants idle callback or not

virtual bool wantsWindowActiveStateChangeNotification | ( |  | ) | const
| inline virtual

whether this view wants to be informed if the window's active state changes

## Member Data Documentation

uint32_t idleRate
| static

global idle rate in Hz, defaults to 30 Hz

bool kDirtyCallAlwaysOnMainThread = false
| static

if this is true, setting a view dirty will call invalid() instead of checking it in idle.

Default value is false.

The documentation for this class was generated from the following files:

- cview.h
- cview.cpp